from playwright.sync_api import Playwright, sync_playwright, expect

import re
import json
import cyaml
import crawler


# 爬虫启动
def CrawlerBaidu():
    with sync_playwright() as playwright:
        return GetBaiduCompany(playwright)


# 爬取百度的数据
def GetBaiduCompany(playwright: Playwright) -> int:
    # 获取需要爬取数据的公司
    name, url = crawler.GetCompany(1)
    if url != "":
        headless = bool(cyaml.data[cyaml.data["env"]]["headless"])
        browser = playwright.chromium.launch(headless=headless)
        context = browser.new_context(viewport={"width": 1280, "height": 960})
        page = context.new_page()

        crawler.Log(name + "-百度开始请求数据：" + url)
        page.goto(url)
        all_summary = page.locator('div[class^="lemmaSummary"]').all_text_contents()
        intro = re.sub(r'\[[\d-]+\]', '', str(all_summary))
        crawler.Log(name + "-获取到百度数据：" + intro)
        try:
            if name != "" and intro != '[]':
                intro_new = str(intro[2:len(intro) - 2])
                new_string1 = re.sub(r'\\n', "", intro_new)
                new_string2 = re.sub(r'\\xa0', "", new_string1)

                name2 = crawler.SaveCompanyData(name, 1, new_string2)
                if name2 != "":
                    crawler.Log(name2 + ":百度数据，写入成功")
                else:
                    crawler.Log(name + ":百度数据，写入失败")
            else:
                num = crawler.CheckUpperLimit(name, "baike")
                upper_limit = int(cyaml.data[cyaml.data["env"]]["upper_limit"])
                if num < upper_limit:
                    # 未达到请求上限，重新推入redis队列
                    crawler.Log(name + ":百科查询为空，未达到请求上限，重新推入redis队列")
                    crawler.DoSpiderCompany(name, "baike")
        except Exception as e:
            crawler.Log(name + " 百科请求报错：" + str(e))
            if name != "":
                path = "img/" + name + "-baike.png"
                page.screenshot(path=path)
                # 重新将公司推进队列
                # crawler.DoSpiderCompany(name, "baike")
        finally:
            context.close()
            browser.close()
            return 100
